#include <vcl_iostream.h>
#include <vbl/vbl_ref_count.h>
#include <vbl/vbl_smart_ptr.h>


class big_foo : public vbl_ref_count {
public:
  big_foo( double dflt=0.0 )
  { for ( int i=0; i<1024; ++i ) data[i] = dflt; }

  double get( int i ) const { return data[i]; }
  void set( int i, double x ) { data[i] = x; }

private:
  double data[1024];
};

//  Create a typedef for the big_foo smart pointer
typedef vbl_smart_ptr<big_foo> big_foo_sptr;

int
main()
{
  big_foo_sptr p = new big_foo( 1.0 );
  {
    big_foo_sptr q = p;  // alias
    q->set( 0, 23.0 );
  }  // q is out of scope so it is gone

  //  p remains, but its data has been changed.
  vcl_cout << "p's first value = " 
	   << p -> get( 0 ) << vcl_endl;
  return 0;
}

//  Instantiating here.  This isn't the common practice
#include <vbl/vbl_smart_ptr.txx>
VBL_SMART_PTR_INSTANTIATE(big_foo);

