#include <vcl_iostream.h>
#include <vxl_config.h>  // generated file
#include <vil/vil_load.h> 
#include <vil/vil_save.h> 
#include <vil/vil_image_view.h> 
#include <vil/algo/vil_line_filter.h>
#include <vnl/vnl_math.h>   // vnl_math_rnd

int main(int argc, char **argv) 
{   
  vil_image_view<vxl_byte> img;    
  img = vil_load(argv[1]); 

  vil_image_view<vxl_byte> line_dir;   // results storage
  vil_image_view<float> line_str;

  // Apply line finder
  vil_line_filter<vxl_byte> line_filter;
  line_filter . dark_lines_5x5( line_dir, line_str, img );
  
  // Find the maximum strength line output
  float max_str = 0.0;
  for ( unsigned int i=0; i<line_str.ni(); ++i )
    for ( unsigned int j=0; j<line_str.nj(); ++j )
      if ( line_str(i,j) > max_str ) max_str = line_str(i,j);
  
  //  Create scaled image of results
  vil_image_view<vxl_byte> scaled_results( line_str.ni(), line_str.nj() );
  for ( unsigned int i=0; i<line_str.ni(); ++i )
    for ( unsigned int j=0; j<line_str.nj(); ++j )
      scaled_results(i,j) = vnl_math_rnd( line_str(i,j) / max_str * 255 );
  
  vil_save(scaled_results, argv[2]); 
  return 0; 
} 
