#include <vcl_iostream.h>
#include <vnl/vnl_math.h>
#include <vnl/vnl_vector.h>
#include <vnl/vnl_matrix.h>
#include <vnl/algo/vnl_svd.h>

int main()
{
  vnl_vector<double> p(4);   // 4-component vector
  
  p(0) = 1.0;
  p(1) = 0.3;
  p(2) = -0.5;
  p(3) = 2.0;

  //  4x4 matrix, filled with 0.0
  vnl_matrix<double> m(4, 4, 0.0);
  m(0,0) = 1.0;   m(0,1) = 5.0;   m(0,2) = -2.0;  m(0,3) = 0.5;
  m(1,0) = 0.0;   m(1,1) = 1.0;   m(1,2) = 3.0;   m(1,3) = -3.0;
  m(2,0) = -2.0;  m(2,1) = 15.0;  m(2,2) = 4.0;   m(2,3) = 0.5;
  m(3,0) = 1.0;   m(3,1) = -0.2;  m(3,2) = 1.0;   m(3,3) = 9.5;

  vcl_cout << "p = " << p << "\n"
           << "m = \n" << m << "\n" << vcl_endl;
  
  //  The computation of the svd is computed in the constructor.
  vnl_svd<double> svd(m);

  vcl_cout << "SVD of m:\n" << "U = " << svd.U() << "\n"
	   << "V = " << svd.V() << vcl_endl;

  vcl_cout << "Singular values:  ";
  for ( unsigned int i=0; i<4; ++i )
    vcl_cout << svd.W(i) << " ";
  vcl_cout << vcl_endl;

  return 0;
}
