#ifndef rgrl_est_quadratic_h_
#define rgrl_est_quadratic_h_

//:
// \file
// \author Amitha Perera
// \date   Feb 2003

#include "rgrl_estimator.h"

//: Quadratic transform estimator
//
class rgrl_est_quadratic
  : public rgrl_estimator
{
public:
  rgrl_est_quadratic( unsigned int param_dof,
                      unsigned int num_samples_for_fit );

  rgrl_est_quadratic();

  //: Estimates an quadratic transform.
  //
  // The return pointer is to a rgrl_trans_quadratic object.
  //
  // \sa rgrl_estimator::estimate
  //
  rgrl_transformation_sptr
  estimate( rgrl_set_of<rgrl_match_set_sptr> const& matches,
            rgrl_transformation const& cur_transform ) const;


  //: Estimates an quadratic transform.
  //
  // The return pointer is to a rgrl_trans_quadratic object.
  //
  // \sa rgrl_estimator::estimate
  //
  rgrl_transformation_sptr
  estimate( rgrl_match_set_sptr matches,
            rgrl_transformation const& cur_transform ) const;


  rgrl_transformation_type type() const;
};

#endif // rgrl_est_quadratic_h_
