#ifndef rgrl_est_similarity2d_h_
#define rgrl_est_similarity2d_h_

//:
// \file
// \author Charlene Tsai
// \date   Sep 2003

#include "rgrl_estimator.h"

//: 2D similarity transform estimator
//
class rgrl_est_similarity2d
  : public rgrl_estimator
{
public:
  rgrl_est_similarity2d( unsigned int param_dof,
                       unsigned int num_samples_for_fit );

  rgrl_est_similarity2d();

  //: Estimates an 2D similarity transform.
  //
  // The return pointer is to a rgrl_trans_similarity object.
  //
  // \sa rgrl_estimator::estimate
  //
  rgrl_transformation_sptr
  estimate( rgrl_set_of<rgrl_match_set_sptr> const& matches,
            rgrl_transformation const& cur_transform ) const;


  //: Estimates an similarity transform.
  //
  // The return pointer is to a rgrl_trans_similarity object.
  //
  // \sa rgrl_estimator::estimate
  //
  rgrl_transformation_sptr
  estimate( rgrl_match_set_sptr matches,
            rgrl_transformation const& cur_transform ) const;


  rgrl_transformation_type type() const;
};

#endif // rgrl_est_similarity2d_h_
