//:
// \file
// \author Amitha Perera
// \date   Feb 2003

#include "rgrl_estimator.h"

#include "rgrl_set_of.h"
#include "rgrl_match_set_sptr.h"

rgrl_estimator::
rgrl_estimator( unsigned int param_dof,
                unsigned int num_samples_for_fit )
  : dof_( param_dof ),
    num_samples_for_fit_( num_samples_for_fit )
{
}

rgrl_estimator::
rgrl_estimator()
  : dof_( 0 ),
    num_samples_for_fit_( 0 )
{
}

rgrl_estimator::
~rgrl_estimator()
{
}


rgrl_transformation_sptr
rgrl_estimator::
estimate( rgrl_match_set_sptr matches,
          rgrl_transformation const& cur_transform ) const
{
  rgrl_set_of<rgrl_match_set_sptr> set;
  set.push_back( matches );
  return estimate( set, cur_transform );
}
