#ifndef rgrl_view_gen_null_h_
#define rgrl_view_gen_null_h_

// \file
// \author Amitha Perera
// \date   Feb 2003

#include "rgrl_view_generator.h"

//: The null view generator: does nothing
//
// This view "generator" doesn't change the view in any way.
//
class rgrl_view_gen_null
  : public rgrl_view_generator
{
public:
  //:
  rgrl_view_gen_null( );

  //: Does nothing: the output view is the input view.
  virtual
  rgrl_view_sptr next_view( rgrl_view const&                        curr_view,
			    rgrl_set_of<rgrl_match_set_sptr> const& curr_matches,
			    rgrl_set_of<rgrl_scale_sptr> const&     curr_scales,
                            vcl_vector< rgrl_transformation_sptr >  const&  xforms,
                            vcl_vector<rgrl_estimator_sptr> const&  models,
                            vcl_vector<double > const &             errors);
};

#endif // rgrl_view_gen_null_h_
