//:
// \file
// \author Amitha Perera

#include "rgrl_view_gen_single.h"

#include <vcl_cassert.h>

#include "rgrl_roi.h"
#include "rgrl_estimator.h"
#include "rgrl_transformation.h"
#include "rgrl_view.h"


rgrl_view_gen_single::
rgrl_view_gen_single()
{
}


rgrl_view_sptr
rgrl_view_gen_single::
next_view( rgrl_view const&               curr_view,
           rgrl_set_of<rgrl_match_set_sptr> const&    /*curr_matches*/,
           rgrl_set_of<rgrl_scale_sptr> const&        /*curr_scales*/,
           vcl_vector< rgrl_transformation_sptr >  const&  xforms,
           vcl_vector<rgrl_estimator_sptr> const&  models,
           vcl_vector<double > const &    /*errors*/)
{
  assert( models.size() == 1 && xforms.size() == 1);
  return new rgrl_view( curr_view.from_image_roi(), curr_view.to_image_roi(), curr_view.region(), curr_view.global_region(), models[0], xforms[0], curr_view.resolution() );
}
