#ifndef rgrl_view_gen_single_h_
#define rgrl_view_gen_single_h_

// \file
// \author Amitha Perera
// \date   Feb 2003

#include "rgrl_view_generator.h"

#include "rgrl_estimator_sptr.h"
#include "rgrl_roi.h"

//: View of a single model over the whole data set.
//
//  It is equivalent to pure-feature based
class rgrl_view_gen_single
  : public rgrl_view_generator
{
public:
  rgrl_view_gen_single( );

  //: Does nothing. 
  //
  //The new view recieves the regions and the resolution from \a
  //curr_view, and updates the xform and estimator from \a xforms and
  //\a models, respectively.
  //
  virtual
  rgrl_view_sptr next_view( rgrl_view const&               curr_view,
			    rgrl_set_of<rgrl_match_set_sptr> const&   curr_matches,
			    rgrl_set_of<rgrl_scale_sptr> const&       curr_scales,
			    vcl_vector< rgrl_transformation_sptr >  const&  xforms,
                            vcl_vector<rgrl_estimator_sptr> const&  models,
                            vcl_vector<double > const &             errors);

};

#endif // rgrl_view_gen_single_h_
