#include <testlib/testlib_test.h>

#include <rgrl/rgrl_initializer_prior.h>
#include <rgrl/rgrl_trans_affine.h>
#include <rgrl/rgrl_est_affine.h>
#include <rgrl/rgrl_view.h>
#include <rgrl/rgrl_scale.h>

static
void
test_single_prior()
{
  rgrl_transformation_sptr trans =
    new rgrl_trans_affine( vnl_matrix<double>( 3, 3, vnl_matrix_identity ),
                           vnl_vector<double>( 3, 0.0 ),
                           vnl_matrix<double>( 12, 12, 0.0 ) );

  rgrl_estimator_sptr est = new rgrl_est_affine;

  rgrl_roi roi(3);
  rgrl_view_sptr view = new rgrl_view( roi,
                                       roi,
                                       roi,
                                       roi,
                                       est,
                                       trans,
                                       0 );

  rgrl_initializer_sptr init = new rgrl_initializer_prior( view );

  rgrl_transformation_sptr t;
  rgrl_view_sptr v;

  testlib_test_begin( "First get is good" );
  rgrl_scale_sptr s;
  testlib_test_perform( init->next_initial( v, s ) && v->xform_estimate()==trans && v==view );

  // the view and transform shouldn't change
  //
  testlib_test_begin( "No second" );
  testlib_test_perform( !init->next_initial( v, s ) && v->xform_estimate()==trans && v==view );

  testlib_test_begin( "No third" );
  testlib_test_perform( !init->next_initial( v, s ) && v->xform_estimate()==trans && v==view );
  
}

MAIN( test_initializer )
{
  START( "initializers" );

  test_single_prior();

  SUMMARY();
}
